=== removed file 'drizzled/function/str/database.cc'
--- drizzled/function/str/database.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/database.cc	1970-01-01 00:00:00 +0000
@@ -1,42 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-
-#include <drizzled/function/str/database.h>
-#include <drizzled/session.h>
-
-namespace drizzled
-{
-
-String *Item_func_database::val_str(String *str)
-{
-  assert(fixed == 1);
-  Session *session= current_session;
-  if (session->db.empty())
-  {
-    null_value= 1;
-    return 0;
-  }
-  else
-    str->copy(session->db.c_str(), session->db.length(), system_charset_info);
-  return str;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/database.h'
--- drizzled/function/str/database.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/database.h	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_DATABASE_H
-#define DRIZZLED_FUNCTION_STR_DATABASE_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-class Item_func_database :public Item_str_func
-{
-public:
-  Item_func_database() :Item_str_func() {}
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
-    maybe_null=1;
-  }
-  const char *func_name() const { return "database"; }
-  const char *fully_qualified_func_name() const { return "database()"; }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_DATABASE_H */

=== removed file 'drizzled/function/str/hex.cc'
--- drizzled/function/str/hex.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/hex.cc	1970-01-01 00:00:00 +0000
@@ -1,127 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-#include <drizzled/util/convert.h>
-#include <drizzled/function/str/hex.h>
-#include "drizzled/internal/m_string.h"
-
-namespace drizzled
-{
-
-/**
-  convert a hex digit into number.
-*/
-static int hexchar_to_int(char c)
-{
-  if (c <= '9' && c >= '0')
-    return c-'0';
-  c|=32;
-  if (c <= 'f' && c >= 'a')
-    return c-'a'+10;
-  return -1;
-}
-
-String *Item_func_hex::val_str(String *str)
-{
-  String *res;
-  assert(fixed == 1);
-  if (args[0]->result_type() != STRING_RESULT)
-  {
-    uint64_t dec;
-    char ans[65],*ptr;
-    /* Return hex of unsigned int64_t value */
-    if (args[0]->result_type() == REAL_RESULT ||
-        args[0]->result_type() == DECIMAL_RESULT)
-    {
-      double val= args[0]->val_real();
-      if ((val <= (double) INT64_MIN) ||
-          (val >= (double) (uint64_t) UINT64_MAX))
-        dec=  ~(int64_t) 0;
-      else
-        dec= (uint64_t) (val + (val > 0 ? 0.5 : -0.5));
-    }
-    else
-      dec= (uint64_t) args[0]->val_int();
-
-    if ((null_value= args[0]->null_value))
-      return 0;
-    ptr= internal::int64_t2str(dec,ans,16);
-    if (str->copy(ans,(uint32_t) (ptr-ans),default_charset()))
-      return &my_empty_string;			// End of memory
-    return str;
-  }
-
-  /* Convert given string to a hex string, character by character */
-  res= args[0]->val_str(str);
-  if (!res || tmp_value.alloc(res->length()*2+1))
-  {
-    null_value=1;
-    return 0;
-  }
-  null_value=0;
-  tmp_value.length(res->length()*2);
-
-  (void) drizzled_string_to_hex((char*) tmp_value.ptr(), res->ptr(),
-                                res->length());
-  return &tmp_value;
-}
-
-  /** Convert given hex string to a binary string. */
-
-String *Item_func_unhex::val_str(String *str)
-{
-  const char *from, *end;
-  char *to;
-  String *res;
-  uint32_t length;
-  assert(fixed == 1);
-
-  res= args[0]->val_str(str);
-  if (!res || tmp_value.alloc(length= (1+res->length())/2))
-  {
-    null_value=1;
-    return 0;
-  }
-
-  from= res->ptr();
-  null_value= 0;
-  tmp_value.length(length);
-  to= (char*) tmp_value.ptr();
-  if (res->length() % 2)
-  {
-    int hex_char;
-    *to++= hex_char= hexchar_to_int(*from++);
-    if ((null_value= (hex_char == -1)))
-      return 0;
-  }
-  for (end=res->ptr()+res->length(); from < end ; from+=2, to++)
-  {
-    int hex_char;
-    *to= (hex_char= hexchar_to_int(from[0])) << 4;
-    if ((null_value= (hex_char == -1)))
-      return 0;
-    *to|= hex_char= hexchar_to_int(from[1]);
-    if ((null_value= (hex_char == -1)))
-      return 0;
-  }
-  return &tmp_value;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/hex.h'
--- drizzled/function/str/hex.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/hex.h	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_HEX_H
-#define DRIZZLED_FUNCTION_STR_HEX_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-class Item_func_hex :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_hex(Item *a) :Item_str_func(a) {}
-  const char *func_name() const { return "hex"; }
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    collation.set(default_charset());
-    decimals=0;
-    max_length=args[0]->max_length*2*collation.collation->mbmaxlen;
-  }
-};
-
-class Item_func_unhex :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_unhex(Item *a) :Item_str_func(a)
-  {
-    /* there can be bad hex strings */
-    maybe_null= 1;
-  }
-  const char *func_name() const { return "unhex"; }
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    collation.set(&my_charset_bin);
-    decimals=0;
-    max_length=(1+args[0]->max_length)/2;
-  }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_HEX_H */

=== removed file 'drizzled/function/str/reverse.cc'
--- drizzled/function/str/reverse.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/reverse.cc	1970-01-01 00:00:00 +0000
@@ -1,79 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-
-#include <drizzled/function/str/reverse.h>
-
-namespace drizzled
-{
-
-String *Item_func_reverse::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res = args[0]->val_str(str);
-  char *ptr, *end, *tmp;
-
-  if ((null_value=args[0]->null_value))
-    return 0;
-  /* An empty string is a special case as the string pointer may be null */
-  if (!res->length())
-    return &my_empty_string;
-  if (tmp_value.alloced_length() < res->length() &&
-      tmp_value.realloc(res->length()))
-  {
-    null_value= 1;
-    return 0;
-  }
-  tmp_value.length(res->length());
-  tmp_value.set_charset(res->charset());
-  ptr= (char *) res->ptr();
-  end= ptr + res->length();
-  tmp= (char *) tmp_value.ptr() + tmp_value.length();
-  if (use_mb(res->charset()))
-  {
-    register uint32_t l;
-    while (ptr < end)
-    {
-      if ((l= my_ismbchar(res->charset(),ptr,end)))
-      {
-        tmp-= l;
-        memcpy(tmp,ptr,l);
-        ptr+= l;
-      }
-      else
-        *--tmp= *ptr++;
-    }
-  }
-  else
-  {
-    while (ptr < end)
-      *--tmp= *ptr++;
-  }
-  return &tmp_value;
-}
-
-
-void Item_func_reverse::fix_length_and_dec()
-{
-  collation.set(args[0]->collation);
-  max_length = args[0]->max_length;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/reverse.h'
--- drizzled/function/str/reverse.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/reverse.h	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_REVERSE_H
-#define DRIZZLED_FUNCTION_STR_REVERSE_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-class Item_func_reverse :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_reverse(Item *a) :Item_str_func(a) {}
-  String *val_str(String *);
-  void fix_length_and_dec();
-  const char *func_name() const { return "reverse"; }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_REVERSE_H */

=== modified file 'drizzled/function/str/strfunc.cc'
--- drizzled/function/str/strfunc.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/strfunc.cc	2010-02-19 07:27:21 +0000
@@ -28,7 +28,6 @@
 #include "config.h"
 #include <zlib.h>
 #include <drizzled/query_id.h>
-#include <uuid/uuid.h>
 #include <drizzled/error.h>
 #include <drizzled/function/str/strfunc.h>
 

=== removed file 'drizzled/function/str/substr.cc'
--- drizzled/function/str/substr.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/substr.cc	1970-01-01 00:00:00 +0000
@@ -1,231 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-
-#include <drizzled/function/str/substr.h>
-
-#include <algorithm>
-
-using namespace std;
-
-namespace drizzled
-{
-
-String *Item_func_substr::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res  = args[0]->val_str(str);
-  /* must be int64_t to avoid truncation */
-  int64_t start= args[1]->val_int();
-  /* Assumes that the maximum length of a String is < INT32_MAX. */
-  /* Limit so that code sees out-of-bound value properly. */
-  int64_t length= arg_count == 3 ? args[2]->val_int() : INT32_MAX;
-  int64_t tmp_length;
-
-  if ((null_value=(args[0]->null_value || args[1]->null_value ||
-		   (arg_count == 3 && args[2]->null_value))))
-    return 0;
-
-  /* Negative or zero length, will return empty string. */
-  if ((arg_count == 3) && (length <= 0) &&
-      (length == 0 || !args[2]->unsigned_flag))
-    return &my_empty_string;
-
-  /* Assumes that the maximum length of a String is < INT32_MAX. */
-  /* Set here so that rest of code sees out-of-bound value as such. */
-  if ((length <= 0) || (length > INT32_MAX))
-    length= INT32_MAX;
-
-  /* if "unsigned_flag" is set, we have a *huge* positive number. */
-  /* Assumes that the maximum length of a String is < INT32_MAX. */
-  if ((!args[1]->unsigned_flag && (start < INT32_MIN || start > INT32_MAX)) ||
-      (args[1]->unsigned_flag && ((uint64_t) start > INT32_MAX)))
-    return &my_empty_string;
-
-  start= ((start < 0) ? res->numchars() + start : start - 1);
-  start= res->charpos((int) start);
-  if ((start < 0) || ((uint) start + 1 > res->length()))
-    return &my_empty_string;
-
-  length= res->charpos((int) length, (uint32_t) start);
-  tmp_length= res->length() - start;
-  length= min(length, tmp_length);
-
-  if (!start && (int64_t) res->length() == length)
-    return res;
-  tmp_value.set(*res, (uint32_t) start, (uint32_t) length);
-  return &tmp_value;
-}
-
-void Item_func_substr::fix_length_and_dec()
-{
-  max_length=args[0]->max_length;
-
-  collation.set(args[0]->collation);
-  if (args[1]->const_item())
-  {
-    int32_t start= (int32_t) args[1]->val_int();
-    if (start < 0)
-      max_length= ((uint)(-start) > max_length) ? 0 : (uint)(-start);
-    else
-      max_length-= min((uint)(start - 1), max_length);
-  }
-  if (arg_count == 3 && args[2]->const_item())
-  {
-    int32_t length= (int32_t) args[2]->val_int();
-    if (length <= 0)
-      max_length=0;
-    else
-      set_if_smaller(max_length,(uint) length);
-  }
-  max_length*= collation.collation->mbmaxlen;
-}
-
-
-void Item_func_substr_index::fix_length_and_dec()
-{
-  max_length= args[0]->max_length;
-
-  if (agg_arg_charsets(collation, args, 2, MY_COLL_CMP_CONV, 1))
-    return;
-}
-
-
-String *Item_func_substr_index::val_str(String *str)
-{
-  assert(fixed == 1);
-  String *res= args[0]->val_str(str);
-  String *delimiter= args[1]->val_str(&tmp_value);
-  int32_t count= (int32_t) args[2]->val_int();
-  uint32_t offset;
-
-  if (args[0]->null_value || args[1]->null_value || args[2]->null_value)
-  {					// string and/or delim are null
-    null_value=1;
-    return 0;
-  }
-  null_value=0;
-  uint32_t delimiter_length= delimiter->length();
-  if (!res->length() || !delimiter_length || !count)
-    return &my_empty_string;		// Wrong parameters
-
-  res->set_charset(collation.collation);
-
-  if (use_mb(res->charset()))
-  {
-    const char *ptr= res->ptr();
-    const char *strend= ptr+res->length();
-    const char *end= strend-delimiter_length+1;
-    const char *search= delimiter->ptr();
-    const char *search_end= search+delimiter_length;
-    int32_t n=0,c=count,pass;
-    register uint32_t l;
-    for (pass=(count>0);pass<2;++pass)
-    {
-      while (ptr < end)
-      {
-        if (*ptr == *search)
-        {
-	  register char *i,*j;
-	  i=(char*) ptr+1; j=(char*) search+1;
-	  while (j != search_end)
-	    if (*i++ != *j++) goto skip;
-	  if (pass==0) ++n;
-	  else if (!--c) break;
-	  ptr+= delimiter_length;
-	  continue;
-	}
-    skip:
-        if ((l=my_ismbchar(res->charset(), ptr,strend))) ptr+=l;
-        else ++ptr;
-      } /* either not found or got total number when count<0 */
-      if (pass == 0) /* count<0 */
-      {
-        c+=n+1;
-        if (c<=0) return res; /* not found, return original string */
-        ptr=res->ptr();
-      }
-      else
-      {
-        if (c) return res; /* Not found, return original string */
-        if (count>0) /* return left part */
-        {
-	  tmp_value.set(*res,0,(ulong) (ptr-res->ptr()));
-        }
-        else /* return right part */
-        {
-	  ptr+= delimiter_length;
-	  tmp_value.set(*res,(ulong) (ptr-res->ptr()), (ulong) (strend-ptr));
-        }
-      }
-    }
-  }
-  else
-  {
-    if (count > 0)
-    {					// start counting from the beginning
-      for (offset=0; ; offset+= delimiter_length)
-      {
-        if ((int) (offset= res->strstr(*delimiter, offset)) < 0)
-          return res;			// Didn't find, return org string
-        if (!--count)
-        {
-          tmp_value.set(*res,0,offset);
-          break;
-        }
-      }
-    }
-    else
-    {
-      /*
-        Negative index, start counting at the end
-      */
-      for (offset=res->length(); offset ;)
-      {
-        /*
-          this call will result in finding the position pointing to one
-          address space less than where the found substring is located
-          in res
-        */
-        if ((int) (offset= res->strrstr(*delimiter, offset)) < 0)
-          return res;			// Didn't find, return org string
-        /*
-          At this point, we've searched for the substring
-          the number of times as supplied by the index value
-        */
-        if (!++count)
-        {
-          offset+= delimiter_length;
-          tmp_value.set(*res,offset,res->length()- offset);
-          break;
-        }
-      }
-    }
-  }
-  /*
-    We always mark tmp_value as const so that if val_str() is called again
-    on this object, we don't disrupt the contents of tmp_value when it was
-    derived from another String.
-  */
-  tmp_value.mark_as_const();
-  return (&tmp_value);
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/substr.h'
--- drizzled/function/str/substr.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/substr.h	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_SUBSTR_H
-#define DRIZZLED_FUNCTION_STR_SUBSTR_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-class Item_func_substr :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_substr(Item *a,Item *b) :Item_str_func(a,b) {}
-  Item_func_substr(Item *a,Item *b,Item *c) :Item_str_func(a,b,c) {}
-  String *val_str(String *);
-  void fix_length_and_dec();
-  const char *func_name() const { return "substr"; }
-};
-
-
-class Item_func_substr_index :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_substr_index(Item *a,Item *b,Item *c) :Item_str_func(a,b,c) {}
-  String *val_str(String *);
-  void fix_length_and_dec();
-  const char *func_name() const { return "substring_index"; }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_SUBSTR_H */

=== removed file 'drizzled/function/str/uuid.cc'
--- drizzled/function/str/uuid.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/uuid.cc	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-
-#include <drizzled/function/str/uuid.h>
-#include <uuid/uuid.h>
-
-namespace drizzled
-{
-
-String *Item_func_uuid::val_str(String *str)
-{
-  uuid_t uu;
-  char *uuid_string;
-
-  /* 36 characters for uuid string +1 for NULL */
-  str->realloc(36+1);
-  str->length(36);
-  str->set_charset(system_charset_info);
-  uuid_string= (char *) str->ptr();
-  uuid_generate_time(uu);
-  uuid_unparse(uu, uuid_string);
-
-  return str;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/uuid.h'
--- drizzled/function/str/uuid.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/uuid.h	1970-01-01 00:00:00 +0000
@@ -1,48 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_UUID_H
-#define DRIZZLED_FUNCTION_STR_UUID_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-#define UUID_LENGTH (8+1+4+1+4+1+4+1+12)
-class Item_func_uuid: public Item_str_func
-{
-public:
-  Item_func_uuid(): Item_str_func() {}
-  void fix_length_and_dec() {
-    collation.set(system_charset_info);
-    /*
-       NOTE! uuid() should be changed to use 'ascii'
-       charset when hex(), format(), md5(), etc, and implicit
-       number-to-string conversion will use 'ascii'
-    */
-    max_length= UUID_LENGTH * system_charset_info->mbmaxlen;
-  }
-  const char *func_name() const{ return "uuid"; }
-  String *val_str(String *);
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_UUID_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-02-22 16:14:47 +0000
+++ drizzled/include.am	2010-02-23 21:26:50 +0000
@@ -141,11 +141,9 @@
 			      drizzled/function/str/concat.h \
 			      drizzled/function/str/conv.h \
 			      drizzled/function/str/conv_charset.h \
-			      drizzled/function/str/database.h \
 			      drizzled/function/str/elt.h \
 			      drizzled/function/str/export_set.h \
 			      drizzled/function/str/format.h \
-			      drizzled/function/str/hex.h \
 			      drizzled/function/str/insert.h \
 			      drizzled/function/str/left.h \
 			      drizzled/function/str/load_file.h \
@@ -154,15 +152,12 @@
 			      drizzled/function/str/quote.h \
 			      drizzled/function/str/repeat.h \
 			      drizzled/function/str/replace.h \
-			      drizzled/function/str/reverse.h \
 			      drizzled/function/str/right.h \
 			      drizzled/function/str/set_collation.h \
 			      drizzled/function/str/str_conv.h \
 			      drizzled/function/str/strfunc.h \
-			      drizzled/function/str/substr.h \
 			      drizzled/function/str/trim.h \
 			      drizzled/function/str/user.h \
-			      drizzled/function/str/uuid.h \
 			      drizzled/function/time/curdate.h \
 			      drizzled/function/time/date.h \
 			      drizzled/function/time/date_add_interval.h \
@@ -540,11 +535,9 @@
 			   drizzled/function/str/concat.cc \
 			   drizzled/function/str/conv.cc \
 			   drizzled/function/str/conv_charset.cc \
-			   drizzled/function/str/database.cc \
 			   drizzled/function/str/elt.cc \
 			   drizzled/function/str/export_set.cc \
 			   drizzled/function/str/format.cc \
-			   drizzled/function/str/hex.cc \
 			   drizzled/function/str/insert.cc \
 			   drizzled/function/str/left.cc \
 			   drizzled/function/str/load_file.cc \
@@ -553,15 +546,12 @@
 			   drizzled/function/str/quote.cc \
 			   drizzled/function/str/repeat.cc \
 			   drizzled/function/str/replace.cc \
-			   drizzled/function/str/reverse.cc \
 			   drizzled/function/str/right.cc \
 			   drizzled/function/str/set_collation.cc \
 			   drizzled/function/str/str_conv.cc \
 			   drizzled/function/str/strfunc.cc \
-			   drizzled/function/str/substr.cc \
 			   drizzled/function/str/trim.cc \
 			   drizzled/function/str/user.cc \
-			   drizzled/function/str/uuid.cc \
 			   drizzled/function/time/curdate.cc \
 			   drizzled/function/time/date.cc \
 			   drizzled/function/time/date_add_interval.cc \

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2010-02-04 08:14:46 +0000
+++ drizzled/item/create.cc	2010-02-19 07:27:21 +0000
@@ -31,15 +31,12 @@
 #include <drizzled/function/str/elt.h>
 #include <drizzled/function/str/export_set.h>
 #include <drizzled/function/str/format.h>
-#include <drizzled/function/str/hex.h>
 #include <drizzled/function/str/load_file.h>
 #include <drizzled/function/str/make_set.h>
 #include <drizzled/function/str/pad.h>
 #include <drizzled/function/str/repeat.h>
 #include <drizzled/function/str/str_conv.h>
-#include <drizzled/function/str/substr.h>
 #include <drizzled/function/str/trim.h>
-#include <drizzled/function/str/uuid.h>
 
 #include <drizzled/function/time/date_format.h>
 #include <drizzled/function/time/dayname.h>
@@ -708,21 +705,6 @@
 };
 
 
-class Create_func_hex : public Create_func_arg1
-{
-public:
-  using Create_func_arg1::create;
-
-  virtual Item *create(Session *session, Item *arg1);
-
-  static Create_func_hex s_singleton;
-
-protected:
-  Create_func_hex() {}
-  virtual ~Create_func_hex() {}
-};
-
-
 class Create_func_ifnull : public Create_func_arg2
 {
 public:
@@ -1277,21 +1259,6 @@
 };
 
 
-class Create_func_substr_index : public Create_func_arg3
-{
-public:
-  using Create_func_arg3::create;
-
-  virtual Item *create(Session *session, Item *arg1, Item *arg2, Item *arg3);
-
-  static Create_func_substr_index s_singleton;
-
-protected:
-  Create_func_substr_index() {}
-  virtual ~Create_func_substr_index() {}
-};
-
-
 class Create_func_tan : public Create_func_arg1
 {
 public:
@@ -1367,21 +1334,6 @@
 };
 
 
-class Create_func_unhex : public Create_func_arg1
-{
-public:
-  using Create_func_arg1::create;
-
-  virtual Item *create(Session *session, Item *arg1);
-
-  static Create_func_unhex s_singleton;
-
-protected:
-  Create_func_unhex() {}
-  virtual ~Create_func_unhex() {}
-};
-
-
 class Create_func_unix_timestamp : public Create_native_func
 {
 public:
@@ -1395,21 +1347,6 @@
 };
 
 
-class Create_func_uuid : public Create_func_arg0
-{
-public:
-  using Create_func_arg0::create;
-
-  virtual Item *create(Session *session);
-
-  static Create_func_uuid s_singleton;
-
-protected:
-  Create_func_uuid() {}
-  virtual ~Create_func_uuid() {}
-};
-
-
 class Create_func_weekday : public Create_func_arg1
 {
 public:
@@ -2041,16 +1978,6 @@
   return new (session->mem_root) Item_func_max(*item_list);
 }
 
-
-Create_func_hex Create_func_hex::s_singleton;
-
-Item*
-Create_func_hex::create(Session *session, Item *arg1)
-{
-  return new (session->mem_root) Item_func_hex(arg1);
-}
-
-
 Create_func_ifnull Create_func_ifnull::s_singleton;
 
 Item*
@@ -2572,14 +2499,6 @@
 }
 
 
-Create_func_substr_index Create_func_substr_index::s_singleton;
-
-Item*
-Create_func_substr_index::create(Session *session, Item *arg1, Item *arg2, Item *arg3)
-{
-  return new (session->mem_root) Item_func_substr_index(arg1, arg2, arg3);
-}
-
 Create_func_tan Create_func_tan::s_singleton;
 
 Item*
@@ -2614,16 +2533,6 @@
   return new (session->mem_root) Item_func_ucase(arg1);
 }
 
-
-Create_func_unhex Create_func_unhex::s_singleton;
-
-Item*
-Create_func_unhex::create(Session *session, Item *arg1)
-{
-  return new (session->mem_root) Item_func_unhex(arg1);
-}
-
-
 Create_func_unix_timestamp Create_func_unix_timestamp::s_singleton;
 
 Item*
@@ -2659,15 +2568,6 @@
 }
 
 
-Create_func_uuid Create_func_uuid::s_singleton;
-
-Item*
-Create_func_uuid::create(Session *session)
-{
-  return new (session->mem_root) Item_func_uuid();
-}
-
-
 Create_func_weekday Create_func_weekday::s_singleton;
 
 Item*
@@ -2725,7 +2625,6 @@
   { { C_STRING_WITH_LEN("FROM_DAYS") }, BUILDER(Create_func_from_days)},
   { { C_STRING_WITH_LEN("FROM_UNIXTIME") }, BUILDER(Create_func_from_unixtime)},
   { { C_STRING_WITH_LEN("GREATEST") }, BUILDER(Create_func_greatest)},
-  { { C_STRING_WITH_LEN("HEX") }, BUILDER(Create_func_hex)},
   { { C_STRING_WITH_LEN("IFNULL") }, BUILDER(Create_func_ifnull)},
   { { C_STRING_WITH_LEN("INSTR") }, BUILDER(Create_func_instr)},
   { { C_STRING_WITH_LEN("ISNULL") }, BUILDER(Create_func_isnull)},
@@ -2765,15 +2664,12 @@
   { { C_STRING_WITH_LEN("SPACE") }, BUILDER(Create_func_space)},
   { { C_STRING_WITH_LEN("SQRT") }, BUILDER(Create_func_sqrt)},
   { { C_STRING_WITH_LEN("STRCMP") }, BUILDER(Create_func_strcmp)},
-  { { C_STRING_WITH_LEN("SUBSTRING_INDEX") }, BUILDER(Create_func_substr_index)},
   { { C_STRING_WITH_LEN("TAN") }, BUILDER(Create_func_tan)},
   { { C_STRING_WITH_LEN("TIME_FORMAT") }, BUILDER(Create_func_time_format)},
   { { C_STRING_WITH_LEN("TO_DAYS") }, BUILDER(Create_func_to_days)},
   { { C_STRING_WITH_LEN("UCASE") }, BUILDER(Create_func_ucase)},
-  { { C_STRING_WITH_LEN("UNHEX") }, BUILDER(Create_func_unhex)},
   { { C_STRING_WITH_LEN("UNIX_TIMESTAMP") }, BUILDER(Create_func_unix_timestamp)},
   { { C_STRING_WITH_LEN("UPPER") }, BUILDER(Create_func_ucase)},
-  { { C_STRING_WITH_LEN("UUID") }, BUILDER(Create_func_uuid)},
   { { C_STRING_WITH_LEN("WEEKDAY") }, BUILDER(Create_func_weekday)},
 
   { {0, 0}, NULL}

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2010-02-18 16:16:20 +0000
+++ drizzled/parser.h	2010-02-23 21:26:50 +0000
@@ -21,15 +21,12 @@
 #include <drizzled/function/locate.h>
 #include <drizzled/function/str/char.h>
 #include <drizzled/function/str/collation.h>
-#include <drizzled/function/str/database.h>
 #include <drizzled/function/str/insert.h>
 #include <drizzled/function/str/left.h>
 #include <drizzled/function/str/repeat.h>
 #include <drizzled/function/str/replace.h>
-#include <drizzled/function/str/reverse.h>
 #include <drizzled/function/str/right.h>
 #include <drizzled/function/str/set_collation.h>
-#include <drizzled/function/str/substr.h>
 #include <drizzled/function/str/trim.h>
 #include <drizzled/function/str/user.h>
 

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-02-16 17:17:31 +0000
+++ drizzled/sql_yacc.yy	2010-02-23 21:26:50 +0000
@@ -301,6 +301,21 @@
   return false;
 }
 
+static Item* reserved_keyword_function(const std::string &name, List<Item> *item_list)
+{
+  const plugin::Function *udf= plugin::Function::get(name.c_str(), name.length());
+  Item *item= NULL;
+
+  if (udf)
+  {
+    item= Create_udf_func::s_singleton.create(current_session, udf, item_list);
+  } else {
+    my_error(ER_SP_DOES_NOT_EXIST, MYF(0), "FUNCTION", name.c_str());
+  }
+
+  return item;
+}
+
 } /* namespace drizzled; */
 
 using namespace drizzled;
@@ -3074,13 +3089,51 @@
         | SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'
           { $$= new (YYSession->mem_root) Item_date_add_interval($3, $6, $7, 1); }
         | SUBSTRING '(' expr ',' expr ',' expr ')'
-          { $$= new (YYSession->mem_root) Item_func_substr($3,$5,$7); }
+          {
+            std::string reverse_str("substr");
+            List<Item> *args= new (YYSession->mem_root) List<Item>;
+            args->push_back($3);
+            args->push_back($5);
+            args->push_back($7);
+            if (! ($$= reserved_keyword_function(reverse_str, args)))
+            {
+              DRIZZLE_YYABORT;
+            }
+          }
         | SUBSTRING '(' expr ',' expr ')'
-          { $$= new (YYSession->mem_root) Item_func_substr($3,$5); }
+          {
+            std::string reverse_str("substr");
+            List<Item> *args= new (YYSession->mem_root) List<Item>;
+            args->push_back($3);
+            args->push_back($5);
+            if (! ($$= reserved_keyword_function(reverse_str, args)))
+            {
+              DRIZZLE_YYABORT;
+            }
+          }
         | SUBSTRING '(' expr FROM expr FOR_SYM expr ')'
-          { $$= new (YYSession->mem_root) Item_func_substr($3,$5,$7); }
+          {
+            std::string reverse_str("substr");
+            List<Item> *args= new (YYSession->mem_root) List<Item>;
+            args->push_back($3);
+            args->push_back($5);
+            args->push_back($7);
+            if (! ($$= reserved_keyword_function(reverse_str, args)))
+            {
+              DRIZZLE_YYABORT;
+            }
+          }
         | SUBSTRING '(' expr FROM expr ')'
-          { $$= new (YYSession->mem_root) Item_func_substr($3,$5); }
+          {
+            std::string reverse_str("substr");
+            List<Item> *args= new (YYSession->mem_root) List<Item>;
+            args->push_back($3);
+            args->push_back($5);
+            if (! ($$= reserved_keyword_function(reverse_str, args)))
+            {
+              DRIZZLE_YYABORT;
+            }
+          }
         | SYSDATE optional_braces
           { $$= new (YYSession->mem_root) Item_func_sysdate_local(); }
         | SYSDATE '(' expr ')'
@@ -3111,8 +3164,12 @@
           { $$= new (YYSession->mem_root) Item_func_collation($3); }
         | DATABASE '(' ')'
           {
-            $$= new (YYSession->mem_root) Item_func_database();
-          }
+            std::string database_str("database");
+            if (! ($$= reserved_keyword_function(database_str, NULL)))
+            {
+              DRIZZLE_YYABORT;
+            }
+	  }
         | IF '(' expr ',' expr ',' expr ')'
           { $$= new (YYSession->mem_root) Item_func_if($3,$5,$7); }
         | MICROSECOND_SYM '(' expr ')'
@@ -3126,7 +3183,15 @@
         | REPLACE '(' expr ',' expr ',' expr ')'
           { $$= new (YYSession->mem_root) Item_func_replace($3,$5,$7); }
         | REVERSE_SYM '(' expr ')'
-          { $$= new (YYSession->mem_root) Item_func_reverse($3); }
+          {
+            std::string reverse_str("reverse");
+            List<Item> *args= new (YYSession->mem_root) List<Item>;
+            args->push_back($3);
+            if (! ($$= reserved_keyword_function(reverse_str, args)))
+            {
+              DRIZZLE_YYABORT;
+            }
+          }
         | TRUNCATE_SYM '(' expr ',' expr ')'
           { $$= new (YYSession->mem_root) Item_func_round($3,$5,1); }
         ;

=== added directory 'plugin/database_function'
=== added file 'plugin/database_function/database_function.cc'
--- plugin/database_function/database_function.cc	1970-01-01 00:00:00 +0000
+++ plugin/database_function/database_function.cc	2010-02-23 21:26:50 +0000
@@ -0,0 +1,85 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/session.h>
+#include <drizzled/function/str/strfunc.h>
+
+using namespace drizzled;
+
+class DatabaseFunction :public Item_str_func
+{
+public:
+  DatabaseFunction() :Item_str_func() {}
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
+    maybe_null=1;
+  }
+  const char *func_name() const { return "database"; }
+  const char *fully_qualified_func_name() const { return "database()"; }
+};
+
+String *DatabaseFunction::val_str(String *str)
+{
+  assert(fixed == 1);
+  Session *session= current_session;
+  if (session->db.empty())
+  {
+    null_value= 1;
+    return 0;
+  }
+  else
+    str->copy(session->db.c_str(), session->db.length(), system_charset_info);
+  return str;
+}
+
+plugin::Create_function<DatabaseFunction> *database_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  database_function= new plugin::Create_function<DatabaseFunction>("database");
+  registry.add(database_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(database_function);
+   delete database_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "database_function",
+  "1.0",
+  "Stewart Smith",
+  "returns the current database",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added file 'plugin/database_function/plugin.ini'
--- plugin/database_function/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/database_function/plugin.ini	2010-02-15 01:56:32 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=DATABASE function
+description=function that returns the current database
+load_by_default=yes

=== added directory 'plugin/hex_functions'
=== added file 'plugin/hex_functions/hex_functions.cc'
--- plugin/hex_functions/hex_functions.cc	1970-01-01 00:00:00 +0000
+++ plugin/hex_functions/hex_functions.cc	2010-02-23 21:26:50 +0000
@@ -0,0 +1,199 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include <drizzled/util/convert.h>
+#include "drizzled/internal/m_string.h"
+
+#include <drizzled/plugin/function.h>
+#include <drizzled/function/str/strfunc.h>
+
+using namespace drizzled;
+
+class HexFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  HexFunction() :Item_str_func() {}
+  const char *func_name() const { return "hex"; }
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    collation.set(default_charset());
+    decimals=0;
+    max_length=args[0]->max_length*2*collation.collation->mbmaxlen;
+  }
+
+  bool check_argument_count(int n) { return n == 1; }
+};
+
+class UnHexFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  UnHexFunction() :Item_str_func()
+  {
+    /* there can be bad hex strings */
+    maybe_null= 1;
+  }
+  const char *func_name() const { return "unhex"; }
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    collation.set(&my_charset_bin);
+    decimals=0;
+    max_length=(1+args[0]->max_length)/2;
+  }
+  bool check_argument_count(int n) { return n == 1; }
+};
+
+/**
+  convert a hex digit into number.
+*/
+static int hexchar_to_int(char c)
+{
+  if (c <= '9' && c >= '0')
+    return c-'0';
+  c|=32;
+  if (c <= 'f' && c >= 'a')
+    return c-'a'+10;
+  return -1;
+}
+
+String *HexFunction::val_str(String *str)
+{
+  String *res;
+  assert(fixed == 1);
+  if (args[0]->result_type() != STRING_RESULT)
+  {
+    uint64_t dec;
+    char ans[65],*ptr;
+    /* Return hex of unsigned int64_t value */
+    if (args[0]->result_type() == REAL_RESULT ||
+        args[0]->result_type() == DECIMAL_RESULT)
+    {
+      double val= args[0]->val_real();
+      if ((val <= (double) INT64_MIN) ||
+          (val >= (double) (uint64_t) UINT64_MAX))
+        dec=  ~(int64_t) 0;
+      else
+        dec= (uint64_t) (val + (val > 0 ? 0.5 : -0.5));
+    }
+    else
+      dec= (uint64_t) args[0]->val_int();
+
+    if ((null_value= args[0]->null_value))
+      return 0;
+    ptr= internal::int64_t2str(dec,ans,16);
+    if (str->copy(ans,(uint32_t) (ptr-ans),default_charset()))
+      return &my_empty_string;			// End of memory
+    return str;
+  }
+
+  /* Convert given string to a hex string, character by character */
+  res= args[0]->val_str(str);
+  if (!res || tmp_value.alloc(res->length()*2+1))
+  {
+    null_value=1;
+    return 0;
+  }
+  null_value=0;
+  tmp_value.length(res->length()*2);
+
+  (void) drizzled_string_to_hex((char*) tmp_value.ptr(), res->ptr(),
+                                res->length());
+  return &tmp_value;
+}
+
+  /** Convert given hex string to a binary string. */
+
+String *UnHexFunction::val_str(String *str)
+{
+  const char *from, *end;
+  char *to;
+  String *res;
+  uint32_t length;
+  assert(fixed == 1);
+
+  res= args[0]->val_str(str);
+  if (!res || tmp_value.alloc(length= (1+res->length())/2))
+  {
+    null_value=1;
+    return 0;
+  }
+
+  from= res->ptr();
+  null_value= 0;
+  tmp_value.length(length);
+  to= (char*) tmp_value.ptr();
+  if (res->length() % 2)
+  {
+    int hex_char;
+    *to++= hex_char= hexchar_to_int(*from++);
+    if ((null_value= (hex_char == -1)))
+      return 0;
+  }
+  for (end=res->ptr()+res->length(); from < end ; from+=2, to++)
+  {
+    int hex_char;
+    *to= (hex_char= hexchar_to_int(from[0])) << 4;
+    if ((null_value= (hex_char == -1)))
+      return 0;
+    *to|= hex_char= hexchar_to_int(from[1]);
+    if ((null_value= (hex_char == -1)))
+      return 0;
+  }
+  return &tmp_value;
+}
+
+plugin::Create_function<HexFunction> *hex_function= NULL;
+plugin::Create_function<UnHexFunction> *unhex_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  hex_function= new plugin::Create_function<HexFunction>("hex");
+  unhex_function= new plugin::Create_function<UnHexFunction>("unhex");
+  registry.add(hex_function);
+  registry.add(unhex_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(hex_function);
+   registry.remove(unhex_function);
+   delete hex_function;
+   delete unhex_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "hex_functions",
+  "1.0",
+  "Stewart Smith",
+  "Convert a string to HEX() or from UNHEX()",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added file 'plugin/hex_functions/plugin.ini'
--- plugin/hex_functions/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/hex_functions/plugin.ini	2010-02-15 02:54:58 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=HEX() and UNHEX() functions
+description=converting strings to and from hexadecimal
+load_by_default=yes

=== added directory 'plugin/reverse_function'
=== added file 'plugin/reverse_function/plugin.ini'
--- plugin/reverse_function/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/reverse_function/plugin.ini	2010-02-15 02:27:14 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=REVERSE function
+description=function that reverses a string
+load_by_default=yes

=== added file 'plugin/reverse_function/reverse_function.cc'
--- plugin/reverse_function/reverse_function.cc	1970-01-01 00:00:00 +0000
+++ plugin/reverse_function/reverse_function.cc	2010-02-23 21:26:50 +0000
@@ -0,0 +1,123 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/plugin/function.h>
+#include <drizzled/function/str/strfunc.h>
+
+using namespace drizzled;
+
+class ReverseFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  ReverseFunction() :Item_str_func() {}
+  String *val_str(String *);
+  void fix_length_and_dec();
+  const char *func_name() const { return "reverse"; }
+
+  bool check_argument_count(int n)
+  {
+    return n == 1;
+  }
+};
+
+String *ReverseFunction::val_str(String *str)
+{
+  assert(fixed == 1);
+  String *res = args[0]->val_str(str);
+  char *ptr, *end, *tmp;
+
+  if ((null_value=args[0]->null_value))
+    return 0;
+  /* An empty string is a special case as the string pointer may be null */
+  if (!res->length())
+    return &my_empty_string;
+  if (tmp_value.alloced_length() < res->length() &&
+      tmp_value.realloc(res->length()))
+  {
+    null_value= 1;
+    return 0;
+  }
+  tmp_value.length(res->length());
+  tmp_value.set_charset(res->charset());
+  ptr= (char *) res->ptr();
+  end= ptr + res->length();
+  tmp= (char *) tmp_value.ptr() + tmp_value.length();
+  if (use_mb(res->charset()))
+  {
+    register uint32_t l;
+    while (ptr < end)
+    {
+      if ((l= my_ismbchar(res->charset(),ptr,end)))
+      {
+        tmp-= l;
+        memcpy(tmp,ptr,l);
+        ptr+= l;
+      }
+      else
+        *--tmp= *ptr++;
+    }
+  }
+  else
+  {
+    while (ptr < end)
+      *--tmp= *ptr++;
+  }
+  return &tmp_value;
+}
+
+void ReverseFunction::fix_length_and_dec()
+{
+  collation.set(args[0]->collation);
+  max_length = args[0]->max_length;
+}
+
+plugin::Create_function<ReverseFunction> *reverse_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  reverse_function= new plugin::Create_function<ReverseFunction>("reverse");
+  registry.add(reverse_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(reverse_function);
+   delete reverse_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "reverse_function",
+  "1.0",
+  "Stewart Smith",
+  "reverses a string",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added directory 'plugin/substr_functions'
=== added file 'plugin/substr_functions/plugin.ini'
--- plugin/substr_functions/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/substr_functions/plugin.ini	2010-02-15 03:55:09 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=SUBSTRING() and SUBSTRING_INDEX() functions
+description=SUBSTRING and SUBSTRING_INDEX functions
+load_by_default=yes

=== added file 'plugin/substr_functions/substr_functions.cc'
--- plugin/substr_functions/substr_functions.cc	1970-01-01 00:00:00 +0000
+++ plugin/substr_functions/substr_functions.cc	2010-02-23 21:26:50 +0000
@@ -0,0 +1,292 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/plugin/function.h>
+#include <algorithm>
+
+using namespace std;
+using namespace drizzled;
+
+#include <drizzled/function/str/strfunc.h>
+
+class SubstrFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  SubstrFunction() :Item_str_func() {}
+
+  String *val_str(String *);
+  void fix_length_and_dec();
+  const char *func_name() const { return "substr"; }
+
+  bool check_argument_count(int n) { return n == 2 || n == 3; }
+};
+
+
+class SubstrIndexFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  SubstrIndexFunction() :Item_str_func() {}
+
+  String *val_str(String *);
+  void fix_length_and_dec();
+  const char *func_name() const { return "substring_index"; }
+
+  bool check_argument_count(int n) { return n == 3; }
+};
+
+String *SubstrFunction::val_str(String *str)
+{
+  assert(fixed == 1);
+  String *res  = args[0]->val_str(str);
+  /* must be int64_t to avoid truncation */
+  int64_t start= args[1]->val_int();
+  /* Assumes that the maximum length of a String is < INT32_MAX. */
+  /* Limit so that code sees out-of-bound value properly. */
+  int64_t length= arg_count == 3 ? args[2]->val_int() : INT32_MAX;
+  int64_t tmp_length;
+
+  if ((null_value=(args[0]->null_value || args[1]->null_value ||
+		   (arg_count == 3 && args[2]->null_value))))
+    return 0;
+
+  /* Negative or zero length, will return empty string. */
+  if ((arg_count == 3) && (length <= 0) &&
+      (length == 0 || !args[2]->unsigned_flag))
+    return &my_empty_string;
+
+  /* Assumes that the maximum length of a String is < INT32_MAX. */
+  /* Set here so that rest of code sees out-of-bound value as such. */
+  if ((length <= 0) || (length > INT32_MAX))
+    length= INT32_MAX;
+
+  /* if "unsigned_flag" is set, we have a *huge* positive number. */
+  /* Assumes that the maximum length of a String is < INT32_MAX. */
+  if ((!args[1]->unsigned_flag && (start < INT32_MIN || start > INT32_MAX)) ||
+      (args[1]->unsigned_flag && ((uint64_t) start > INT32_MAX)))
+    return &my_empty_string;
+
+  start= ((start < 0) ? res->numchars() + start : start - 1);
+  start= res->charpos((int) start);
+  if ((start < 0) || ((uint) start + 1 > res->length()))
+    return &my_empty_string;
+
+  length= res->charpos((int) length, (uint32_t) start);
+  tmp_length= res->length() - start;
+  length= min(length, tmp_length);
+
+  if (!start && (int64_t) res->length() == length)
+    return res;
+  tmp_value.set(*res, (uint32_t) start, (uint32_t) length);
+  return &tmp_value;
+}
+
+void SubstrFunction::fix_length_and_dec()
+{
+  max_length=args[0]->max_length;
+
+  collation.set(args[0]->collation);
+  if (args[1]->const_item())
+  {
+    int32_t start= (int32_t) args[1]->val_int();
+    if (start < 0)
+      max_length= ((uint)(-start) > max_length) ? 0 : (uint)(-start);
+    else
+      max_length-= min((uint)(start - 1), max_length);
+  }
+  if (arg_count == 3 && args[2]->const_item())
+  {
+    int32_t length= (int32_t) args[2]->val_int();
+    if (length <= 0)
+      max_length=0;
+    else
+      set_if_smaller(max_length,(uint) length);
+  }
+  max_length*= collation.collation->mbmaxlen;
+}
+
+
+void SubstrIndexFunction::fix_length_and_dec()
+{
+  max_length= args[0]->max_length;
+
+  if (agg_arg_charsets(collation, args, 2, MY_COLL_CMP_CONV, 1))
+    return;
+}
+
+
+String *SubstrIndexFunction::val_str(String *str)
+{
+  assert(fixed == 1);
+  String *res= args[0]->val_str(str);
+  String *delimiter= args[1]->val_str(&tmp_value);
+  int32_t count= (int32_t) args[2]->val_int();
+  uint32_t offset;
+
+  if (args[0]->null_value || args[1]->null_value || args[2]->null_value)
+  {					// string and/or delim are null
+    null_value=1;
+    return 0;
+  }
+  null_value=0;
+  uint32_t delimiter_length= delimiter->length();
+  if (!res->length() || !delimiter_length || !count)
+    return &my_empty_string;		// Wrong parameters
+
+  res->set_charset(collation.collation);
+
+  if (use_mb(res->charset()))
+  {
+    const char *ptr= res->ptr();
+    const char *strend= ptr+res->length();
+    const char *end= strend-delimiter_length+1;
+    const char *search= delimiter->ptr();
+    const char *search_end= search+delimiter_length;
+    int32_t n=0,c=count,pass;
+    register uint32_t l;
+    for (pass=(count>0);pass<2;++pass)
+    {
+      while (ptr < end)
+      {
+        if (*ptr == *search)
+        {
+	  register char *i,*j;
+	  i=(char*) ptr+1; j=(char*) search+1;
+	  while (j != search_end)
+	    if (*i++ != *j++) goto skip;
+	  if (pass==0) ++n;
+	  else if (!--c) break;
+	  ptr+= delimiter_length;
+	  continue;
+	}
+    skip:
+        if ((l=my_ismbchar(res->charset(), ptr,strend))) ptr+=l;
+        else ++ptr;
+      } /* either not found or got total number when count<0 */
+      if (pass == 0) /* count<0 */
+      {
+        c+=n+1;
+        if (c<=0) return res; /* not found, return original string */
+        ptr=res->ptr();
+      }
+      else
+      {
+        if (c) return res; /* Not found, return original string */
+        if (count>0) /* return left part */
+        {
+	  tmp_value.set(*res,0,(ulong) (ptr-res->ptr()));
+        }
+        else /* return right part */
+        {
+	  ptr+= delimiter_length;
+	  tmp_value.set(*res,(ulong) (ptr-res->ptr()), (ulong) (strend-ptr));
+        }
+      }
+    }
+  }
+  else
+  {
+    if (count > 0)
+    {					// start counting from the beginning
+      for (offset=0; ; offset+= delimiter_length)
+      {
+        if ((int) (offset= res->strstr(*delimiter, offset)) < 0)
+          return res;			// Didn't find, return org string
+        if (!--count)
+        {
+          tmp_value.set(*res,0,offset);
+          break;
+        }
+      }
+    }
+    else
+    {
+      /*
+        Negative index, start counting at the end
+      */
+      for (offset=res->length(); offset ;)
+      {
+        /*
+          this call will result in finding the position pointing to one
+          address space less than where the found substring is located
+          in res
+        */
+        if ((int) (offset= res->strrstr(*delimiter, offset)) < 0)
+          return res;			// Didn't find, return org string
+        /*
+          At this point, we've searched for the substring
+          the number of times as supplied by the index value
+        */
+        if (!++count)
+        {
+          offset+= delimiter_length;
+          tmp_value.set(*res,offset,res->length()- offset);
+          break;
+        }
+      }
+    }
+  }
+  /*
+    We always mark tmp_value as const so that if val_str() is called again
+    on this object, we don't disrupt the contents of tmp_value when it was
+    derived from another String.
+  */
+  tmp_value.mark_as_const();
+  return (&tmp_value);
+}
+
+plugin::Create_function<SubstrFunction> *substr_function= NULL;
+plugin::Create_function<SubstrIndexFunction> *substr_index_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  substr_function= new plugin::Create_function<SubstrFunction>("substr");
+  substr_index_function= new plugin::Create_function<SubstrIndexFunction>("substring_index");
+  registry.add(substr_function);
+  registry.add(substr_index_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(substr_function);
+   registry.remove(substr_index_function);
+   delete substr_function;
+   delete substr_index_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "substr_functions",
+  "1.0",
+  "Stewart Smith",
+  "SUBSTR and SUBSTR",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added directory 'plugin/uuid_function'
=== added file 'plugin/uuid_function/plugin.ac'
--- plugin/uuid_function/plugin.ac	1970-01-01 00:00:00 +0000
+++ plugin/uuid_function/plugin.ac	2010-02-19 07:27:21 +0000
@@ -0,0 +1,5 @@
+PANDORA_REQUIRE_LIBUUID
+AS_IF([test "x$ac_cv_libuuid" = "xno"],
+      AC_MSG_WARN([libuuid not found: not building uuid_function plugin.]))
+
+PANDORA_ADD_PLUGIN_DEP_LIB([${LTLIBUUID}])

=== added file 'plugin/uuid_function/plugin.ini'
--- plugin/uuid_function/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/uuid_function/plugin.ini	2010-02-19 07:27:21 +0000
@@ -0,0 +1,6 @@
+[plugin]
+title=UUID() plugin
+description=UUID() function as generated by libuuid
+load_by_default=yes
+ldflags=${LTLIBUUID}
+build_conditional="${ac_cv_libuuid}" = "yes"

=== added file 'plugin/uuid_function/uuid_function.cc'
--- plugin/uuid_function/uuid_function.cc	1970-01-01 00:00:00 +0000
+++ plugin/uuid_function/uuid_function.cc	2010-02-23 21:26:50 +0000
@@ -0,0 +1,93 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include <drizzled/plugin/function.h>
+#include <drizzled/item/func.h>
+#include <drizzled/function/str/strfunc.h>
+#include <uuid/uuid.h>
+
+#define UUID_LENGTH (8+1+4+1+4+1+4+1+12)
+
+using namespace drizzled;
+
+class UuidFunction: public Item_str_func
+{
+public:
+  UuidFunction(): Item_str_func() {}
+  void fix_length_and_dec() {
+    collation.set(system_charset_info);
+    /*
+       NOTE! uuid() should be changed to use 'ascii'
+       charset when hex(), format(), md5(), etc, and implicit
+       number-to-string conversion will use 'ascii'
+    */
+    max_length= UUID_LENGTH * system_charset_info->mbmaxlen;
+  }
+  const char *func_name() const{ return "uuid"; }
+  String *val_str(String *);
+};
+
+String *UuidFunction::val_str(String *str)
+{
+  uuid_t uu;
+  char *uuid_string;
+
+  /* 36 characters for uuid string +1 for NULL */
+  str->realloc(UUID_LENGTH+1);
+  str->length(UUID_LENGTH);
+  str->set_charset(system_charset_info);
+  uuid_string= (char *) str->ptr();
+  uuid_generate_time(uu);
+  uuid_unparse(uu, uuid_string);
+
+  return str;
+}
+
+plugin::Create_function<UuidFunction> *uuid_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  uuid_function= new plugin::Create_function<UuidFunction>("uuid");
+  registry.add(uuid_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(uuid_function);
+   delete uuid_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "uuid",
+  "1.0",
+  "Stewart Smith",
+  "UUID() function using libuuid",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

